/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.dicommodel.visiblelight;

import java.io.IOException;
import java.util.Locale;


import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataSet;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDicomStream;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDictionaryReader;
import cdac.medinfo.sdk.dcm30_04.commoninterface.ITransferSyntax;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.AcquisitionContextModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.CineModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.CommonInstanceReferenceModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.DeviceModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.FrameExtractionModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.GeneralImageModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.ICCProfileModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.ImageIOD;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.MultiFrameModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.SOPCommonModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.SpecimenIdentificationModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.SpecimenModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.VLImageModule;
import cdac.medinfo.sdk.dcm30_04.enums.EnumModality;
import cdac.medinfo.sdk.dcm30_04.enums.EnumModuleNames;
import cdac.medinfo.sdk.dcm30_04.enums.EnumSOPClassUIDs;

import cdac.medinfo.sdk.dcm30_04.exceptions.ConditionFailedException;
import cdac.medinfo.sdk.dcm30_04.exceptions.InvalidIODException;
import cdac.medinfo.sdk.dcm30_04.exceptions.InvalidModuleException;
import cdac.medinfo.sdk.dcm30_04.exceptions.ParseException;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConfig;
import cdac.medinfo.sdk.dcm30_04.utils.DicomLogger;
import cdac.medinfo.sdk.dcm30_04.utils.ResourceBundleWrapper;

/**
 * The Video Microscopic Image IOD specifies the Attributes of Video Microscopic Images. Slide Coordinates shall not be encoded with this IOD.
 */
public class VideoMicroscopicIOD extends ImageIOD 
{
	

	/**
	 * The VIDE o_ microscopi c_ iod.
	 */
	final String VIDEO_MICROSCOPIC_IOD = "VIDEO_MICROSCOPIC_IOD";

	/**
	 * The obj specimen identification module.
	 */
	SpecimenIdentificationModule objSpecimenIdentificationModule = null;

	/**
	 * The obj general image module.
	 */
	GeneralImageModule objGeneralImageModule = null;

	/**
	 * The obj cine module.
	 */
	CineModule objCineModule = null;

	/**
	 * The obj multi frame module.
	 */
	MultiFrameModule objMultiFrameModule = null;

	/**
	 * The obj acquisition context module.
	 */
	AcquisitionContextModule objAcquisitionContextModule = null;

	/**
	 * The obj vl image module.
	 */
	VLImageModule objVLImageModule = null;

	/**
	 * The obj sop common module.
	 */
	SOPCommonModule objSOPCommonModule = null;
	/**
	 * The obj Device module.
	 */
	DeviceModule objDeviceModule = null;
	/**
	 * The obj Specimen module.
	 */
	SpecimenModule objSpecimenModule = null;
	/**
	 * The obj ICC Profile module.
	 */
	ICCProfileModule objICCProfileModule = null;
	/**
	 * The obj Common Instance Reference module.
	 */
	CommonInstanceReferenceModule objCommonInstanceReferenceModule = null;
	/**
	 * The obj Frame Extraction module.
	 */
	FrameExtractionModule objFrameExtractionModule = null;

	/**
	 * Instantiates a new video microscopic iod.
	 */
	public VideoMicroscopicIOD()
	{
		super();
	}

	/**
	 * This constructor initializes the TransferSyntax  in its superclass IOD.
	 * 
	 * @param objITransferSyntax_ - specifies the DICOM Standard defined TransfeSyntax.
	 */
	public VideoMicroscopicIOD(ITransferSyntax objITransferSyntax_)
	{
		super(objITransferSyntax_);
	}

	/**
	 * This constructor initializes the  DictionaryReader
	 * in its superclass IOD.
	 * 
	 * @param objIDictionaryReader_ - specifies the DICOM Dictionary reader to be used .
	 */
	public VideoMicroscopicIOD(IDictionaryReader objIDictionaryReader_)
	{
		super(objIDictionaryReader_);
	}

	/**
	 * This constructor accepts the DataSet from the user   in its superclass IOD.
	 * 
	 * @param objIDataSet_ - specifies the data set to be set in the IOD.
	 */
	public VideoMicroscopicIOD(IDataSet objIDataSet_)
	{
		super(objIDataSet_);
	}

	/**
	 * This constructor initializes the TransferSyntax and DictionaryReader in its super class IOD.
	 * 
	 * @param objITransferSyntax_ specifies the DICOM Standard defined TransfeSyntax.
	 * @param objIDictionaryReader_ specifies the DICOM Dictionary reader to be used .
	 */
	public VideoMicroscopicIOD(ITransferSyntax objITransferSyntax_,IDictionaryReader objIDictionaryReader_)
	{
		super(objITransferSyntax_,objIDictionaryReader_);
	}

	/**
	 * Creates VideoMicroscopicIOD IOD from a DICOM file containing VideoMicroscopicIOD DICOM data.
	 * @param strFileName DICOM File with absolute path.
	 * @throws IOException Exception caused due to wrong I/O operations. 
	 * @throws ParseException signals if some parse exceptions are occurred.
	 * @throws InvalidIODException signals if some IOD exceptions are occurred.
	 */
	public VideoMicroscopicIOD(String strFileName)throws IOException,InvalidIODException
	{
		super(strFileName);
		try
		{
			if(objIDataSet != null)
			{
				String strSOPClassUID = objIDataSet.getSOPClassUID();
				if(strSOPClassUID != null)
				{
					if(!strSOPClassUID.equals(EnumSOPClassUIDs.VIDEOMICROSCOPICIOD.getValue()))
					{
						throw new InvalidIODException(ResourceBundleWrapper.getValue("exceptions", "InvalidIOD.FileNotMatched", new Locale(DicomConfig.createInstance().getLocale())) + VIDEO_MICROSCOPIC_IOD);
					}
				}
				strSOPClassUID = null;
			}
		}
		catch(InvalidIODException iie)
		{
			if(DicomConfig.createInstance().isLoggingOn())
			{
				DicomLogger.getLogger().log(iie.getMessage());
			}
			throw iie;
		}
	}

	/**
	 * Retrieves pre-initialized instance of General Image Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return GeneralImageModule - instance of {@link GeneralImageModule}.
	 */
	public GeneralImageModule getGeneralImageModule()
	{
		if(objGeneralImageModule == null)
		{
			objGeneralImageModule = new GeneralImageModule(objIDataSet);
			return objGeneralImageModule;
		}
		return objGeneralImageModule;
	}

	/**
	 * Retrieves pre-initialized instance of Acquisition Context Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return AcquisitionContextModule - instance of {@link AcquisitionContextModule}.
	 */
	public AcquisitionContextModule getAcquisitionContextModule()
	{
		if(objAcquisitionContextModule == null)
		{
			objAcquisitionContextModule = new AcquisitionContextModule(objIDataSet);
			return objAcquisitionContextModule;
		}
		return objAcquisitionContextModule;
	}

	/**
	 * Retrieves pre-initialized instance of VL Image Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return VLImageModule - instance of {@link VLImageModule}.
	 */
	public VLImageModule getVLImageModule()
	{
		if(objVLImageModule == null)
		{
			objVLImageModule = new VLImageModule(objIDataSet);
			return objVLImageModule;
		}
		return objVLImageModule;
	}

	/**
	 * Retrieves pre-initialized instance of SOP Common Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return objSOPCommonModule - instance of {@link objSOPCommonModule}.
	 */
	public SOPCommonModule getSOPCommonModule()
	{
		if(objSOPCommonModule == null)
		{
			objSOPCommonModule = new SOPCommonModule(objIDataSet);
			return objSOPCommonModule;
		}
		return objSOPCommonModule;
	}

	/**
	 * Retrieves pre-initialized instance of Specimen Identification Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return objSpecimenIdentificationModule - instance of {@link objSpecimenIdentificationModule}.
	 */
	public SpecimenIdentificationModule getSpecimenIdentificationModule()
	{
		if(objSpecimenIdentificationModule == null)
		{
			objSpecimenIdentificationModule = new SpecimenIdentificationModule(objIDataSet);
			return objSpecimenIdentificationModule;
		}
		return objSpecimenIdentificationModule;
	}

	/**
	 * Retrieves pre-initialized instance of Cine Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return objCineModule - instance of {@link objCineModule}.
	 */
	public CineModule getCineModule()
	{
		if(objCineModule == null)
		{
			objCineModule = new CineModule(objIDataSet);
			return objCineModule;
		}
		return objCineModule;
	}

	/**
	 * Retrieves pre-initialized instance of Multi Frame Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return objMultiFrameModule - instance of {@link objMultiFrameModule}.
	 */
	public MultiFrameModule getMultiFrameModule()
	{
		if(objMultiFrameModule == null)
		{
			objMultiFrameModule = new MultiFrameModule(objIDataSet);
			return objMultiFrameModule;
		}
		return objMultiFrameModule;
	}
	/**
	 * Retrieves pre-initialized instance of Device Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return DeviceModule - instance of {@link DeviceModule}.
	 */
	public DeviceModule getDeviceModule()
	{
		if(objDeviceModule == null)
		{
			objDeviceModule = new DeviceModule(objIDataSet);
			return objDeviceModule;
		}
		return objDeviceModule;
	}
	/**
	 * Retrieves pre-initialized instance of Specimen Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return SpecimenModule - instance of {@link SpecimenModule}.
	 */
	public SpecimenModule getSpecimenModule()
	{
		if(objSpecimenModule == null)
		{
			objSpecimenModule = new SpecimenModule(objIDataSet);
			return objSpecimenModule;
		}
		return objSpecimenModule;
	}
	/**
	 * Retrieves pre-initialized instance of ICC Profile Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return ICCProfileModule - instance of {@link ICCProfileModule}.
	 */
	public ICCProfileModule getICCProfileModule()
	{
		if(objICCProfileModule == null)
		{
			objICCProfileModule = new ICCProfileModule(objIDataSet);
			return objICCProfileModule;
		}
		return objICCProfileModule;
	}
	/**
	 * Retrieves pre-initialized instance of Common Instance Reference Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return objSOPCommonModule - instance of {@link CommonInstanceReferenceModule}.
	 */
	public CommonInstanceReferenceModule getCommonInstanceReferenceModule()
	{
		if(objCommonInstanceReferenceModule == null)
		{
			objCommonInstanceReferenceModule = new CommonInstanceReferenceModule(objIDataSet);
			return objCommonInstanceReferenceModule;
		}
		return objCommonInstanceReferenceModule;
	}
	/**
	 * Retrieves pre-initialized instance of Frame Extraction Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return objFrameExtractionModule - instance of {@link FrameExtractionModule}.
	 */
	public FrameExtractionModule getFrameExtractionModule()
	{
		if(objFrameExtractionModule == null)
		{
			objFrameExtractionModule = new FrameExtractionModule(objIDataSet);
			return objFrameExtractionModule;
		}
		return objFrameExtractionModule;
	}
	/**
	 * This method validates VideoMicroscopicIOD according to the Module Table given in The DICOM Standard.
	 * The validate method fails if one of the mandatory modules are absent or any of the
	 * modules are invalid.The validate method also checks for conditional modules.
	 * 
	 * @return boolean - function status indicating success or failure.
	 * 
	 * @throws InvalidIODException - throws when IOD is invalid.
	 */
	public boolean validate() throws InvalidIODException
	{
		/*
		 * This condition calls ImageIOD class's validation which checks for common modules validation
		 */
		super.validate();
		/*
		 * This condition checks for VideoMicroscopicIOD's mandatory modules validation
		 */
		try
		{
			getSpecimenIdentificationModule().validateModule();
			getGeneralImageModule().validateModule();
			getAcquisitionContextModule().validateModule();
			getVLImageModule().validateModule();
			getSOPCommonModule().validateModule();
			getGeneralEquipmentModule().validateModule();
			getCineModule().validateModule();
			getMultiFrameModule().validateModule();

			/*
			 * Validation for attribute PatientOrientation(0020,0020) of GeneralImageModule is implemented at IOD level.
			 * condition :- Required if image does not require Image Orientation (Patient)(0020,0037) and Image Position (Patient)
			 * 				(0020,0032). See C.7.6.1.1.1 for further explanation.
			 * Right now we are taking it as if IOD contains any module which has (0020,0037) and (0020,0032)
			 * and if that module and attribute are compulsory then (0020,0020) is not mandatory.
			 * If no module is there in IOD then (0020,0020) is mandatory.
			 * and if attribute or module is optional or conditional then 0020,0020 is also conditional.
			 * THIS IOD DOES NOT CONTAIN ANY MODULE containing THESE ATTRIBUTES.
			 */
			if( !getGeneralImageModule().isPresent(0x0020,0x0020))
			{
				ConditionFailedException cce = new ConditionFailedException("0020,0020");
				if(DicomConfig.createInstance().isLoggingOn())
					DicomLogger.getLogger().log(cce.getMessage());
				throw cce;

			}
			if(isModulePresent(DeviceModule.objSingleCollection, objIDataSet))
			{
				getDeviceModule().validateModule();
			}
			if(isModulePresent(ICCProfileModule.objSingleCollection, objIDataSet))
			{
				getICCProfileModule().validateModule();
			}
			if(isModulePresent(CommonInstanceReferenceModule.objSingleCollection, objIDataSet))
			{
				getCommonInstanceReferenceModule().validateModule();
			}
			/*
			 * This condition checks for VideoMicroscopicIOD's validation constraints
			 */
			String strModality = getGeneralSeriesModule().getModality();
			if(!strModality.equals(EnumModality.GENERAL_MICROSCOPY.getValue()))
				throw new InvalidIODException("Value of Modality shall be" + EnumModality.GENERAL_MICROSCOPY.getValue());

			// checking for presence of Image data
			if(!isPresent(0x7FE0,0x0010))
			{
				InvalidIODException iie= new InvalidIODException(ResourceBundleWrapper.getValue("exceptions", "ImageData", new Locale(DicomConfig.createInstance().getLocale())));
				if(DicomConfig.createInstance().isLoggingOn())
					DicomLogger.getLogger().log(iie.getMessage());
				throw iie;

			}
		}
		catch(InvalidModuleException ime)
		{
			if(DicomConfig.createInstance().isLoggingOn())
				DicomLogger.getLogger().log(ime.getMessage());
			
				throw new InvalidIODException(VIDEO_MICROSCOPIC_IOD, ime);
		}
		return true;
	}

	/**
	 *  Dumps the Name of IOD,Module and corresponding Attributs of Module.
	 *  @param objIDicomStream - the Stream on which the Data is to be written.
	 *  @throws IOException - Exception is thrown indicating runtime failure of writing operation.
	 */
	public void dumpDICOMInfo(IDicomStream objIDicomStream) throws IOException
	{
		objIDicomStream.writeString(VIDEO_MICROSCOPIC_IOD + "\n");
		super.dumpDICOMInfo(objIDicomStream);

		objIDicomStream.writeString("\t" + getAcquisitionContextModule().getClass().getSimpleName() + "\n");
		getAcquisitionContextModule().dumpDICOMInfo(objIDicomStream);

		objIDicomStream.writeString("\t" + getGeneralImageModule().getClass().getSimpleName() + "\n");
		getGeneralImageModule().dumpDICOMInfo(objIDicomStream);

		objIDicomStream.writeString("\t" + getCineModule().getClass().getSimpleName() + "\n");
		getCineModule().dumpDICOMInfo(objIDicomStream);

		objIDicomStream.writeString("\t" + getMultiFrameModule().getClass().getSimpleName() + "\n");
		getMultiFrameModule().dumpDICOMInfo(objIDicomStream);

		objIDicomStream.writeString("\t" + getSpecimenIdentificationModule().getClass().getSimpleName() + "\n");
		getSpecimenIdentificationModule().dumpDICOMInfo(objIDicomStream);

		objIDicomStream.writeString("\t" + getSOPCommonModule().getClass().getSimpleName() + "\n");
		getSOPCommonModule().dumpDICOMInfo(objIDicomStream);

		objIDicomStream.writeString("\t" + getVLImageModule().getClass().getSimpleName() + "\n");
		getVLImageModule().dumpDICOMInfo(objIDicomStream);
		
		objIDicomStream.writeString("\t" + getDeviceModule().getClass().getSimpleName() + "\n");
		getDeviceModule().dumpDICOMInfo(objIDicomStream);
		
		objIDicomStream.writeString("\t" + getSpecimenModule().getClass().getSimpleName() + "\n");
		getSpecimenModule().dumpDICOMInfo(objIDicomStream);
		
		objIDicomStream.writeString("\t" + getICCProfileModule().getClass().getSimpleName() + "\n");
		getICCProfileModule().dumpDICOMInfo(objIDicomStream);
		
		objIDicomStream.writeString("\t" + getCommonInstanceReferenceModule().getClass().getSimpleName() + "\n");
		getCommonInstanceReferenceModule().dumpDICOMInfo(objIDicomStream);
		
		objIDicomStream.writeString("\t" + getFrameExtractionModule().getClass().getSimpleName() + "\n");
		getFrameExtractionModule().dumpDICOMInfo(objIDicomStream);
	}

	/**
	 * Checks whether the Module is present in the IOD or not.
	 * @param strModuleName String value of module name 
	 * @return boolean - true if the module is present in the IOD, else false is returned.
	 */
	public boolean isModulePresent(String strModuleName)
	{
		if(!super.isModulePresent(strModuleName))
		{
			if(strModuleName == null || strModuleName.equals(""))
				return false;
			if(strModuleName.equalsIgnoreCase(EnumModuleNames.ACQUISITION_CONTEXT_MODULE.getValue()) && isModulePresent(AcquisitionContextModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.GENERAL_IMAGE_MODULE.getValue()) && isModulePresent(GeneralImageModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.MULTI_FRAME_MODULE.getValue()) && isModulePresent(MultiFrameModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.SOP_COMMON_MODULE.getValue()) && isModulePresent(SOPCommonModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.VL_IMAGE_MODULE.getValue()) && isModulePresent(VLImageModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.SPECIMEN_IDENTIFICATION_MODULE.getValue()) && isModulePresent(SpecimenIdentificationModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.CINE_MODULE.getValue()) && isModulePresent(CineModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.DEVICE_MODULE.getValue()) && isModulePresent(DeviceModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.SPECIMEN_MODULE.getValue()) && isModulePresent(SpecimenModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.ICC_PROFILE_MODULE.getValue()) && isModulePresent(ICCProfileModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.COMMON_INSTANCE_REFERENCE_MODULE.getValue()) && isModulePresent(CommonInstanceReferenceModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.FRAME_EXTRACTION_MODULE.getValue()) && isModulePresent(FrameExtractionModule.objSingleCollection))
				return true;
			else
			{
				if(DicomConfig.createInstance().isLoggingOn())
				{
					DicomLogger objDicomLogger = DicomLogger.getLogger();
					objDicomLogger.log(this.getClass().getName() + " : " +ResourceBundleWrapper.getValue("status","ModuleNotPresent",new Locale(DicomConfig.createInstance().getLocale())) + strModuleName);
				}
				return false;
			}
		}
		return true;
	}
}
